/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/
 
/**
	MP3 source config info

	Toni Thomsson, toni@tonjac.org
*/

#ifndef mp3_config_h
#define mp3_config_h

#include <zz_string.h>

/*
;source
source_user=source
source_password=bump8
source_name=radio.tonjac.org
source_bitrate=192
mount=/stream
http_listen_port=8010
cgi=/cgi-bin/mp3_radio.exe
lib_dir=s:\Documents and Settings\tonjac\My Documents\My Music\
m3u_dir=s:\Documents and Settings\tonjac\My Documents\My Playlists\
pause_song=pause.mp3
pause_message=Waiting for a request - Pause music

;icecast
admin_user=admin
admin_password=bump8
server_hostname=localhost
server_port=8000
meta_info_url=/admin/metadata?mount=/stream&mode=updinfo&song=%s

*/

// The class
class Cmp3SourceConfig
{
public:

	//* Construction
	Cmp3SourceConfig();
	~Cmp3SourceConfig();

	static CzzString getDataDir( void );
	static CzzString getM3uDir( void );
	static CzzString getPauseSong( void );
	static CzzString getPauseMessage( void );

	static CzzString getSourceUser( void );
	static CzzString getSourcePwd( void );
	static CzzString getSourceName( void );
	static CzzString getSourceBitrate( void );
	static CzzString getSourceMount( void );

	static CzzString getWebserverPort( void );
	static CzzString getCGIUrl( void );
	static CzzString getAdminUser( void );
	static CzzString getAdminPwd( void );
	static CzzString getServerPort( void );
	static CzzString getServerHost( void );
	static CzzString getServerMetadataUrl( void );
	static CzzString getServerProtocol( void );
	
	static CzzString appName( void );

private:
	static CzzString getEntry( const CzzString& entry );
	static void setEntry( const CzzString& entry, const CzzString& value );
};

#endif // mp3_config_h


