/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

/**
	CGI program for myMusic

	Toni Thomsson, toni@tonjac.org
*/

#include "mp3_cgi_exception.h"
#include "mp3_config.h"
#include "mp3_html_service_manager.h"
#include "mp3_error_render.h"
#include <rpcdce.h>
#include <zz_session_cookie.h>

// Main
int main( int argc, char** argv )
{
	int result = 0;
	Cmp3HtmlServiceManager* sm = NULL;
    CzzSessionCookie* sc = NULL;

	try
	{
		char* cookie = getenv( "HTTP_COOKIE" );
		
        if( cookie == NULL || strlen(cookie) == 0 )
        {
    		sc = new CzzSessionCookie( "TONJAC_MP3_COOKIE", "/" );
            printf( "Set-Cookie: %s\n", sc->getSetHeader().c_str() );
        }
		else
			sc = new CzzSessionCookie( cookie );

		printf( "Content-Type: text/html\n\n" );
				
		sm = new Cmp3HtmlServiceManager( sc->getId() );

		// Execute request !
		sm->execute();

	}
	catch( CzzException& e )
	{
		Cmp3ErrorRender r( &(sc->getId()), NULL, e.GetReason() );
		printf( "%s", r.render().c_str() );
		result = e.GetCode();
	}
	catch( ... )
	{
		Cmp3ErrorRender r( &(sc->getId()), NULL, "Undefined error!" );
		printf( "%s", r.render().c_str() );
		result = -1;
	}

    delete sc;

	return result;

}


