/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

// Implementation of class Cmp3HelpData

#include "mp3_help_data.h"
#include "mp3_config.h"
#include "mp3_svc.h"
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>

// Construction
Cmp3HelpData::Cmp3HelpData( void )
 : CzzDataService( "getHelpData" )
{

}

// Destruction
Cmp3HelpData::~Cmp3HelpData()
{

}

CzzDataServiceReply* Cmp3HelpData::execute( void* session, CzzParameterMap* req )
{

	CzzDataService::execute( session, req );

	CzzDataServiceReply* reply = new CzzDataServiceReply();


	ostringstream fs;
	ifstream f( CzzString::Format( "%s\\%s\\cgi-bin\\help.html", 
		Cmp3Config::getRealDir().c_str(), Cmp3Config::getLang().c_str() ).c_str(), std::ios::binary );

	fs << f.rdbuf();
    
	reply->addField( MP3_FLD_HELP_HTML, fs.str() );

	return reply;
}

int Cmp3HelpData::size()
{
    return sizeof(Cmp3HelpData);
}