/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

// Implementation of class Cmp3MyRadioListData

#include "mp3_http_requester.h"
#include "mp3_myradio_list_data.h"
#include "mp3_config.h"
#include "mp3_svc.h"

// Construction
Cmp3MyRadioListData::Cmp3MyRadioListData( void )
: CzzDataService( "listMyRadioData" )
{

}

// Destruction
Cmp3MyRadioListData::~Cmp3MyRadioListData()
{

}

CzzDataServiceReply* Cmp3MyRadioListData::execute( void* session, CzzParameterMap* req )
{
	CzzDataService::execute( session, req );

	CzzDataServiceReply* reply = new CzzDataServiceReply();
	
	reply->addFieldName( MP3_FLD_REMOVE_SONG );
	reply->addFieldName( MP3_FLD_LIST_RECORD );
	reply->addFieldName( MP3_FLD_SONG_TITLE );

	CzzString cgi = Cmp3Config::getCGIDir();
	CzzString list;
	CzzString now;
	CzzString next;
	CzzString listIndexes;

	try
	{
		Cmp3HttpRequester req;
		list = req.listRadioQueue();
		now  = req.nowPlaying();
		next = req.commingUp();
	}
	catch( ... ) { return reply; }

	char sep[] = "\n\\";
	char* part = NULL;
	char* idx = NULL;
	char* tok = (char*)list.c_str();
	part = strtok( tok, sep );

	while( part != NULL )
	{
		char* name = strtok( NULL, sep );
		char* album = strtok( NULL, sep );
		char* song = strtok( NULL, sep );

		if( name != NULL && album != NULL && song != NULL )
		{
			reply->addFieldValue( CzzString::Format( "%s/mp3_gui.exe?svc=%d&name=%s&album=%s&song=%s", cgi.c_str(), MP3_SVC_LIST_RADIO_REMOVE, urlEncode(name).c_str(), urlEncode(album).c_str(), urlEncode(song).c_str() ) );
			reply->addFieldValue( CzzString::Format( "%s/mp3_gui.exe?svc=%d&name=%s&album=%s", cgi.c_str(), MP3_SVC_LIST_SONGS, urlEncode(name).c_str(), urlEncode(album).c_str() ) );

			if( CzzString( part ) == now )
				reply->addFieldValue( CzzString::Format( "<b>&raquo; %s</b>", part ) );
			else if( CzzString( part ) == next )
				reply->addFieldValue( CzzString::Format( "<b>&#8226; %s</b>", part ) );
			else
				reply->addFieldValue( CzzString(part) );
		}

		part = strtok( NULL, sep );
	}

	return reply;
}

int Cmp3MyRadioListData::size()
{
    return sizeof(Cmp3MyRadioListData);
}