/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

// Implementation of class Cmp3PlaylistContentData

#include "mp3_http_requester.h"
#include "mp3_playlist_content_data.h"
#include "mp3_svc.h"
#include "mp3_config.h"

#include <time.h>
#include <sys/timeb.h>
#include <sys/types.h> 
#include <id3/tag.h>
#include <zz_file.h>
#include <winver.h>

// Construction
Cmp3PlaylistContentData::Cmp3PlaylistContentData( const CzzString& name )
: CzzDataService( "listPlaylistContentData" ), m_Name(name)
{

}

// Destruction
Cmp3PlaylistContentData::~Cmp3PlaylistContentData()
{

}

CzzDataServiceReply* Cmp3PlaylistContentData::execute( void* session, CzzParameterMap* req )
{
	CzzDataService::execute( session, req );

	CzzDataServiceReply* reply = new CzzDataServiceReply();

	
	CzzString name = m_Name;
	CzzString pname;
	CzzString added;
	CzzString nowplaying = "-";
	CzzString commingup = "-";
	

	// Radio
	try
	{
		Cmp3HttpRequester req;
		nowplaying = req.nowPlaying();
		commingup = req.commingUp();
	}
	catch( ... ) {}
	
	if( name == "session" )
	{
		if( Cmp3Config::getLang() == "SE" )
			name = "Ny spellista";
		else
			name = "New playlist";

		pname = "session";
	}
	else
	{
		name = name.substr( 0, name.size()-4 );
		pname = name + ".m3u";
	}

	reply->addField( MP3_FLD_ADD_PLAYLIST_TO_RADIO, CzzString::Format( "%s/mp3_gui.exe?svc=%d&name=%s.m3u", Cmp3Config::getCGIDir().c_str(), MP3_SVC_LIST_RADIO_REPLACE, name.c_str() ));
	reply->addField( MP3_FLD_TITLE_ROW, name );
	reply->addField( MP3_FLD_PLAY_LINK, CzzString::Format( "%s/mp3_playlist.exe?svc=3&name=%s", Cmp3Config::getCGIDir().c_str(), pname.c_str() ));
	reply->addField( MP3_FLD_EMPTY_LINK, CzzString::Format( "%s/mp3_gui.exe?svc=%d&name=%s", Cmp3Config::getCGIDir().c_str(), MP3_SVC_LIST_M3U_DELETE, pname.c_str() ));
	reply->addField( MP3_FLD_SAVE_LINK, CzzString::Format( "%s/mp3_gui.exe?svc=%d&name=session", Cmp3Config::getCGIDir().c_str(), MP3_SVC_LIST_M3U_SAVE ) );
	reply->addField( MP3_FLD_RADIO_LATEST_ADDED, added );
	reply->addField( MP3_FLD_RADIO_NOW_PLAYING, nowplaying );
	reply->addField( MP3_FLD_RADIO_COMMING_UP, commingup );
	
	return reply;
}

int Cmp3PlaylistContentData::size()
{
    return sizeof(Cmp3PlaylistContentData);
}