/* myMusic
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/
 
/**
    Webserver fr myMusic
    Toni Thomsson, toni@tonjac.org
*/

#include "mp3_nt_webservice.h"

#include <zz_arguments.h>
#include <direct.h>

// Main
void _CRTAPI1 main( int argc, char** argv )
{
	CzzString home;
	
	int p = 0;

	for( p = strlen(argv[0]); p > 0; p-- )
	{
		if( argv[0][p] == '\\' )
		{
			home = CzzString(argv[0]).substr(0,p);
			break;
		}
	}

	// Change currdir
	chdir( CzzString(home + "\\cgi-bin").c_str() );

	Cmp3NtWebService* ws = NULL;
	CzzLog log( "mp3_webserver", home + "\\log.ini" );

	try
	{
		CzzArguments args( argc, argv, '-', 1 );

		Cmp3NtWebService::m_Home = home;

		// Create NT service
		ws = new Cmp3NtWebService( home );

		CzzString mode;
		try{ mode = args[ "m" ].LowerCase(); } catch( ... ) {  };

		// Enter mode?
		if( mode.size() )
		{
			bool validmode = false;

			// Install
			if( mode == "install" )
			{
				ws->Install();
				validmode = true;
			}

			// Remove
			if( mode == "remove" )
			{
				ws->Remove();
				validmode = true;
			}

			// Debug
			if( mode == "debug" )
			{
				ws->Debug( argc, argv );
				validmode = true;
			}

			if( !validmode )
				throw CzzException( _LAF, 4711, CzzString::Format( "Otilltet mode '%s'", mode.c_str() ) );
		}
		else
		{
			// If it doesn't match any of the above parameters
		    // the service control manager may be starting the service
		
			// Run the service
			printf( "\nFrsker starta tjnsten, detta kan ta flera sekunder...\n" );
			ws->Start();		
		}
	}

	// Controlled error !
	catch( CzzException& e )
	{
		// This is just to be friendly
		printf( "Anvndning, argument inom parantes valfria:\n" );
		printf( "mp3_source (-m <install|remove|debug>) (<params>)\n" );
		printf( "%d) %s\n", e.GetCode(), e.GetReason().c_str() );
	}

	// Unhandled error !
	catch( ... )
	{
		printf( "Internt fel se loggfilen fr mer information!\n" );
	}

	// Free memory
	if( ws != NULL )
		delete ws;
}


