/* libzzinet
 *
 * This program is distributed under the GNU General Public License, version 2.
 * A copy of this license is included with this source.
 *
 * Copyright 2004-2006, Toni Thomsson <toni@tonjac.org> 
*/

/**
	Reply from a data service

	Toni Thomsson, toni@tonjac.org
*/

#ifndef zz_data_service_reply_h
#define zz_data_service_reply_h

#include <zz_string.h>
#include <vector>
#include <zz_log.h>

class ZZ_API CzzDataServiceReply
{
public:

	CzzDataServiceReply( void );
	~CzzDataServiceReply();

	vector<CzzString>* names( void );
	vector<CzzString>* values( void );

	void addField( const CzzString& name, const CzzString& value );
	void addFieldName( const CzzString& name );
	void addFieldValue( const CzzString& value );

protected:
	CzzLog m_Log;

private:

	vector<CzzString> m_Names;
	vector<CzzString> m_Values;
};

#endif // zz_data_service_reply_h